﻿local tomYeller = CreateFrame('Frame', 'tomYeller')
tomYeller:SetScript('OnEvent', function(self, event, ...) self[event](self, event, ...) end)
tomYeller:RegisterEvent('PLAYER_ENTERING_WORLD')

local L = {}
if GetLocale() == 'frFR' then
	L.rezCombatStart = '{rt8} >>> Début de %s de %s <<< {rt8}'
	L.rezCombatFailed = '{rt8} <<< %s de %s à échoué >>> {rt8}'
	L.rezCombatSucceed = '{rt8} !!! %s de %s !!! {rt8}'
	L.rezCombatLimitReached = '{rt8} !!! Les rez combats sont impossibles !!! {rt8}'
	L.raidAuraApplied = '{rt2} +++ Début de %s +++ {rt2}'
	L.raidAuraRemoved = '{rt2} --- Fin de %s --- {rt2}'
	L.targetAuraApplied = '{rt1} +++ Début de %s sur %s +++ {rt1}'
	L.targetAuraRemoved = '{rt1} --- Fin de %s sur %s --- {rt1}'
	L.targetSpellCast = '{rt3} +++ %s sur %s +++ {rt3}'
	L.interrupt = '{rt7} +++ Interruption de %s de %s +++ {rt7}'
	L.lightWell = '{rt5} !!! %s disponible CLICK CLICK (hors GCD et 20m de porté) !!! {rt5}'
	L.configChan = 'Canaux de sortie de tomYeller pour annoncer les interruptions'
	L.configTell = 'Dire'
	L.configParty = 'Groupe'
	L.configRaid = 'Raid'
	L.configPartySwitch = 'Activer les annonces en groupe'
else
	L.rezCombatStart = '{rt8} >>> %s on %s started <<< {rt8}'
	L.rezCombatFailed = '{rt8} <<< %s on %s failed >>> {rt8}'
	L.rezCombatSucceed = '{rt8} !!! %s on %s !!! {rt8}'
	L.rezCombatLimitReached = '{rt8} !!! Combat rez are impossible !!! {rt8}'
	L.raidAuraApplied = '{rt2} +++ %s started +++ {rt2}'
	L.raidAuraRemoved = '{rt2} --- %s ended --- {rt2}'
	L.targetAuraApplied = '{rt1} +++ %s on %s started +++ {rt1}'
	L.targetAuraRemoved = '{rt1} --- %s on %s ended --- {rt1}'
	L.targetSpellCast = '{rt3} +++ %s on %s +++ {rt3}'
	L.interrupt = '{rt7} +++ %s of %s interrupted +++ {rt7}'
	L.lightWell = '{rt5} !!! %s available CLICK CLICK (out of GCD and range of 20yrd) !!! {rt5}'
	L.configChan = 'tomYeller output channels for interrupts announcements'
	L.configTell = 'Tell'
	L.configParty = 'Party'
	L.configRaid = 'Raid'
	L.configPartySwitch = 'Party announcements for non interrupts annoucements'
end

function tomYeller:RaidAuraComplex(event, timeStamp, spellId)
	if event == 'SPELL_AURA_APPLIED' then
		if (not self.lastAuraApplied[spellId] or (timeStamp - self.lastAuraApplied[spellId]) > 30) then
			self.lastAuraApplied[spellId], self.antiSpam[spellId] = timeStamp, 1
			SendChatMessage(format(L.raidAuraApplied, GetSpellLink(spellId)), self.chan)
		else
			self.antiSpam[spellId] = self.antiSpam[spellId] + 1
		end
	elseif event == 'SPELL_AURA_REMOVED' then
		self.antiSpam[spellId] = self.antiSpam[spellId] - 1
		if self.antiSpam[spellId] ~= 0 then return end
		SendChatMessage(format(L.raidAuraRemoved, GetSpellLink(spellId)), self.chan)
	end
end

function tomYeller:RaidAuraSimple(event, spellId)
	if event == 'SPELL_AURA_APPLIED' then
		SendChatMessage(format(L.raidAuraApplied, GetSpellLink(spellId)), self.chan)
	elseif event == 'SPELL_AURA_REMOVED' then
		SendChatMessage(format(L.raidAuraRemoved, GetSpellLink(spellId)), self.chan)
	end
end

function tomYeller:TargetAura(event, spellId, targetName)
	if event == 'SPELL_AURA_APPLIED' then
		SendChatMessage(format(L.targetAuraApplied, GetSpellLink(spellId), targetName), self.chan)
	elseif event == 'SPELL_AURA_REMOVED' then
		SendChatMessage(format(L.targetAuraRemoved, GetSpellLink(spellId), targetName), self.chan)
	end
end

function tomYeller:RezCombat(event, timeStamp, spellId, targetName, reasonFailed)
	if event == 'SPELL_RESURRECT' then
		SendChatMessage(format(L.rezCombatSucceed, GetSpellLink(spellId), targetName), self.chan)
	elseif event == 'SPELL_CAST_START' then
		SendChatMessage(format(L.rezCombatStart, GetSpellLink(spellId), targetName), self.chan)
	elseif event == 'SPELL_CAST_FAILED' then
		if not self.lastFailedRezCombat or timeStamp - self.lastFailedRezCombat > 1 then
			self.lastFailedRezCombat = timeStamp
			SendChatMessage(format(L.rezCombatFailed, GetSpellLink(spellId), targetName), self.chan)
			if reasonFailed == SPELL_FAILED_IN_COMBAT_RES_LIMIT_REACHED then
				SendChatMessage(L.rezCombatLimitReached, self.chan)
			end
		end
	end
end

function tomYeller:Interrupt(spellLink, targetName)
	local msg = format(L.interrupt, spellLink, targetName)
	for _, dest in pairs(self.chatDest) do
		SendChatMessage(msg, dest)
	end
end

local _, playerClass = UnitClass('player')
if playerClass == 'DEATHKNIGHT' then
	tomYeller.combatRezToTrack = GetSpellInfo(61999)
	tomYeller.COMBAT_LOG_EVENT_UNFILTERED = function(self, _, timeStamp, event, _, _, _, sourceFlags, _, _, targetName, _, _, spellId,_, _, extraArg1)
		if sourceFlags == 0x511 then
			if spellId == 61999 then --Raise ally
				self:RezCombat(event, timeStamp, spellId, targetName or self.combatRezTargetName, extraArg1)
			elseif spellId == 105588 then --Vampiric Brood (DK Tank 4PT13)
				self:RaidAuraComplex(event, timeStamp, spellId)
			elseif event == 'SPELL_INTERRUPT' and next(self.chatDest) then
				self:Interrupt(GetSpellLink(extraArg1), targetName)
			end
		end
	end
elseif playerClass == 'DRUID' then
	tomYeller.combatRezToTrack = GetSpellInfo(20484)
	tomYeller.COMBAT_LOG_EVENT_UNFILTERED = function(self, _, timeStamp, event, _, _, _, sourceFlags, _, _, targetName, _, _, spellId,_, _, extraArg1)
		if sourceFlags == 0x511 then
			if spellId == 20484 then --Rebirth
				self:RezCombat(event, timeStamp, spellId, targetName or self.combatRezTargetName, extraArg1)
			elseif spellId == 740 then --Tranquility
				self:RaidAuraSimple(event, spellId)
			elseif spellId == 29166 and event == 'SPELL_AURA_APPLIED' then --Innervate
				self:TargetAura(event, spellId, targetName)
			elseif spellId == 105737 then --Mass Regeneration (Druid Tank 4PT13)
				self:RaidAuraComplex(event, timeStamp, spellId)
			elseif event == 'SPELL_INTERRUPT' and next(self.chatDest) then
				self:Interrupt(GetSpellLink(extraArg1), targetName)
			end
		end
	end
elseif playerClass == 'HUNTER' then
	tomYeller.COMBAT_LOG_EVENT_UNFILTERED = function(self, _, timeStamp, event, _, _, _, sourceFlags, _, _, targetName, _, _, spellId,_, _, extraArg1)
		if sourceFlags == 0x511 then
			if event == 'SPELL_CAST_SUCCESS' and spellId == 34477 then --Misdirection
				SendChatMessage(format(L.targetSpellCast, GetSpellLink(spellId), targetName), self.chan)
			elseif event == 'SPELL_INTERRUPT' and next(self.chatDest) then
				self:Interrupt(GetSpellLink(extraArg1), targetName)
			end
		elseif sourceFlags == 0x1111 and spellId == 90355 then --Ancient Hysteria
			self:RaidAuraComplex(event, timeStamp, spellId)
		end
	end
elseif playerClass == 'MAGE' then
	tomYeller.COMBAT_LOG_EVENT_UNFILTERED = function(self, _, timeStamp, event, _, _, _, sourceFlags, _, _, targetName, _, _, spellId,_, _, extraArg1)
		if sourceFlags == 0x511 then
			if spellId == 80353 then --Time Warp
				self:RaidAuraComplex(timeStamp, spellId)
			elseif event == 'SPELL_INTERRUPT' and next(self.chatDest) then
				self:Interrupt(GetSpellLink(extraArg1), targetName)
			end
		end
	end
elseif playerClass == 'PALADIN' then
	tomYeller.COMBAT_LOG_EVENT_UNFILTERED = function(self, _, timeStamp, event, _, _, _, sourceFlags, _, _, targetName, _, _, spellId,_, _, extraArg1)
		if sourceFlags == 0x511 then
			if event == 'SPELL_CAST_SUCCESS' and spellId == 633 then --Lay on Hands
				SendChatMessage(format(L.targetSpellCast, GetSpellLink(spellId), targetName), self.chan)
			elseif spellId == 1022 or spellId == 1038 or spellId == 1044 or spellId == 6940 then --Hands of Protection, Salvation, Freedom, Sacrifice
				self:TargetAura(event, spellId, targetName)
			elseif spellId == 31821 then --Aura Mastery
				self:RaidAuraSimple(event, spellId)
			elseif spellId == 70940 then --Divine Guardian
				self:RaidAuraComplex(event, timeStamp, spellId)
			elseif event == 'SPELL_INTERRUPT' and next(self.chatDest) then
				self:Interrupt(GetSpellLink(extraArg1), targetName)
			end
		end
	end
elseif playerClass == 'PRIEST' then
	tomYeller.COMBAT_LOG_EVENT_UNFILTERED = function(self, _, timeStamp, event, _, _, _, sourceFlags, _, _, targetName, _, _, spellId,_, _, extraArg1)
		if sourceFlags == 0x511 then
			if event == 'SPELL_CAST_SUCCESS' and spellId == 724 then --LightWell
				SendChatMessage(format(L.lightWell, GetSpellLink(spellId)), self.chan)
			elseif spellId == 33206 or spellId == 47788 then --Pain Suppression & Guardian Spirit
				self:TargetAura(event, spellId, targetName)
			elseif event == 'SPELL_INTERRUPT' and next(self.chatDest) then
				self:Interrupt(GetSpellLink(extraArg1), targetName)
			end
		elseif sourceFlags == 0x2111 and spellId == 81782 then --Power Word: Barrier
			self:RaidAuraComplex(event, timeStamp, spellId)
		elseif sourceFlags == 0xa28 and event == 'SPELL_AURA_REMOVED' and spellId == 81782 then --Power Word: Barrier
			self:RaidAuraComplex(event, timeStamp, spellId)
		end
	end
elseif playerClass == 'ROGUE' then
	tomYeller.COMBAT_LOG_EVENT_UNFILTERED = function(self, _, timeStamp, event, _, _, _, sourceFlags, _, _, targetName, _, _, spellId,_, _, extraArg1)
		if sourceFlags == 0x511 and event == 'SPELL_INTERRUPT' and next(self.chatDest) then
			self:Interrupt(GetSpellLink(extraArg1), targetName)
		end
	end
elseif playerClass == 'SHAMAN' then
	local summonedGUID = {}
	tomYeller.COMBAT_LOG_EVENT_UNFILTERED = function(self, _, timeStamp, event, _, _, _, sourceFlags, _, targetGUID, targetName, targetFlags, _, spellId,_, _, extraArg1)
		if sourceFlags == 0x511 then
			if spellId == 32182 or spellId == 2825 then --Heroism & Bloodlust
				self:RaidAuraComplex(event, timeStamp, spellId)
			elseif event == 'SPELL_SUMMON' and (spellId == 98008 or spellId == 16190) then --Spirit Link Totem & Mana Tide Totem
				local spellLink = GetSpellLink(spellId)
				summonedGUID[targetGUID] = spellLink
				SendChatMessage(format(L.raidAuraApplied, spellLink), self.chan)
			elseif event == 'SPELL_INTERRUPT' and next(self.chatDest) then
				self:Interrupt(GetSpellLink(extraArg1), targetName)
			end
		elseif targetFlags == 0x2111 and summonedGUID[targetGUID] and event == 'UNIT_DESTROYED' then
			SendChatMessage(format(L.raidAuraRemoved, summonedGUID[targetGUID]), self.chan)
			summonedGUID[targetGUID] = nil
		end
	end
elseif playerClass == 'WARLOCK' then
	tomYeller.combatRezToTrack = GetSpellInfo(20707)
	tomYeller.COMBAT_LOG_EVENT_UNFILTERED = function(self, _, timeStamp, event, _, _, _, sourceFlags, _, _, targetName, _, _, spellId,_, _, extraArg1)
		if sourceFlags == 0x511 then
			if spellId == 20707 or spellId == 95750 then --Soulstone Resurrection
				self:RezCombat(event, timeStamp, spellId, targetName or self.combatRezTargetName, extraArg1)
			elseif event == 'SPELL_INTERRUPT' and next(self.chatDest) then
				self:Interrupt(GetSpellLink(extraArg1), targetName)
			end
		elseif sourceFlags == 0x1111 and event == 'SPELL_INTERRUPT' and next(self.chatDest) then
			self:Interrupt(GetSpellLink(extraArg1), targetName)
		end
	end
elseif playerClass == 'WARRIOR' then
	tomYeller.COMBAT_LOG_EVENT_UNFILTERED = function(self, _, timeStamp, event, _, _, _, sourceFlags, _, _, _, _, _, spellId,_, _, extraArg1)
		if sourceFlags == 0x511 then
			if spellId == 97462 or spellId == 105914 then --Rallying Cry & Shield Fortress (War Tank 4PT13 raid wide shield wall)
				self:RaidAuraComplex(event, timeStamp, spellId)
			elseif event == 'SPELL_INTERRUPT' and next(self.chatDest) then
				self:Interrupt(GetSpellLink(extraArg1), targetName)
			end
		end
	end
end

local db
function tomYeller:PLAYER_ENTERING_WORLD()
	self.chatDest, self.antiSpam, self.lastAuraApplied = {}, {}, {}
	self:UnregisterEvent('PLAYER_ENTERING_WORLD')
	if not _G.tomYellerDB then
		_G.tomYellerDB = {['chatSay'] = true, ['chatParty'] = true, ['chatRaid'] = true, ['alertParty'] = true}
	end
	db = _G.tomYellerDB
	self:RegisterEvent('PARTY_MEMBERS_CHANGED')
	self:PARTY_MEMBERS_CHANGED()
end

function tomYeller:PARTY_MEMBERS_CHANGED()
	self.chatDest.say = db.chatSay and 'SAY' or nil
	if GetRealNumRaidMembers() > 0 then
		self.chatDest.party, self.chatDest.raid, self.chan = db.chatParty and 'PARTY' or nil, db.chatRaid and 'RAID' or nil, 'RAID'
	elseif GetNumPartyMembers() > 0 then
		self.chatDest.party, self.chatDest.raid, self.chan = db.chatParty and 'PARTY' or nil, nil, db.alertParty and 'PARTY' or nil
	else
		self.chatDest.party, self.chatDest.raid, self.chan = nil, nil, nil
	end
	if not self.activated and (self.chan or next(self.chatDest)) then
		self.activated = true
		if self.chan and self.combatRezToTrack then
			self.uss = true
			self:RegisterEvent('UNIT_SPELLCAST_SENT')
		end
		self:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
	elseif self.activated and not self.uss and self.chan and self.combatRezToTrack then
		self.uss = true
		self:RegisterEvent('UNIT_SPELLCAST_SENT')
	elseif self.activated and not (self.chan or next(self.chatDest)) then
		self.activated, self.uss = nil, nil
		self:UnregisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
		self:UnregisterEvent('UNIT_SPELLCAST_SENT')
	end
end

function tomYeller:UNIT_SPELLCAST_SENT(event, unit, spellName, _, targetName)
	if unit == 'player' and self.combatRezToTrack == spellName then
		if targetName == _G.UNKNOWN then
			if UnitIsGhost('target') then
				targetName = UnitName('target')
			elseif UnitIsGhost('mouseover') then
				targetName = UnitName('mouseover')
			end
		end
		self.combatRezTargetName = targetName
	end
end

---Option Panel
local tomYellerConfig = CreateFrame('Frame', nil, InterfaceOptionsFramePanelContainer)
tomYellerConfig.name = 'tomYeller'
tomYellerConfig:Hide()

function tomYellerConfig:addConfigCheckBox(label, y, dbKey)
	local check = CreateFrame('CheckButton', nil, self)
	check:SetSize(26, 26)
	check:SetPoint('TOPLEFT', self, 'TOPLEFT', 15, y)
	check:SetHitRectInsets(0, -100, 0, 0)
	check:SetNormalTexture([[Interface\Buttons\UI-CheckBox-Up]])
	check:SetPushedTexture([[Interface\Buttons\UI-CheckBox-Down]])
	check:SetHighlightTexture([[Interface\Buttons\UI-CheckBox-Highlight]])
	check:SetCheckedTexture([[Interface\Buttons\UI-CheckBox-Check]])
	local fs = check:CreateFontString(nil, 'ARTWORK', 'GameFontHighlight')
	fs:SetPoint('LEFT', check, 'RIGHT', 0, 1)
	fs:SetText(label)
	check:SetScript('OnClick', function(self)
		db[dbKey] = not db[dbKey]
		tomYeller:PARTY_MEMBERS_CHANGED()
	end)
	check:SetChecked(db[dbKey])
	return check
end

tomYellerConfig:SetScript('OnShow', function(self)
	local title = self:CreateFontString(nil, 'ARTWORK', 'GameFontNormalLarge')
	title:SetPoint('TOPLEFT', 16, -16)
	title:SetText('tomYeller')
	local subtitle = self:CreateFontString(nil, 'ARTWORK', 'GameFontHighlightSmall')
	subtitle:SetHeight(32)
	subtitle:SetPoint('TOPLEFT', title, 'BOTTOMLEFT', 0, -8)
	subtitle:SetPoint('RIGHT', self, -32, 0)
	subtitle:SetNonSpaceWrap(true)
	subtitle:SetJustifyH('LEFT')
	subtitle:SetJustifyV('TOP')
	subtitle:SetText(L.configChan)
	local sayChat = self:addConfigCheckBox(L.configTell, -50, 'chatSay')
	local groupChat = self:addConfigCheckBox(L.configParty, -75, 'chatParty')
	local raidChat = self:addConfigCheckBox(L.configRaid, -100, 'chatRaid')
	local alertParty = self:addConfigCheckBox(L.configPartySwitch, -125, 'alertParty')
	self:SetScript('OnShow', nil)
end)
InterfaceOptions_AddCategory(tomYellerConfig)